<template lang="pug">
  .cannedmsg
    b-dropdown(position="is-top-right" @change="selectMsg" v-model="msg")
      b-button(type="is-white" size="is-small" slot="trigger")
        b-icon.gray(icon="quote-right" size="is-small")
      b-dropdown-item.f7.bl.bw2.b--orange.mv1(
        v-for="(msg, index) in list"
        :key="index"
        :value="msg"
      ) {{msg}}
</template>
<script>
import api from '~/utils/api'

const MACRO = {
  memberReportUrl (context) {
    const ticketId = context.ticketId || context.$route.params.ticketId
    if (!ticketId) {
      return null
    }
    const location = window.location
    return `${location.protocol}//${location.host}/item-state/${ticketId}`
  }
}

export default {
  props: {
    ticketId: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      rawMsgList: [],
      msg: ''
    }
  },
  computed: {
    list () {
      return this.rawMsgList.map(this.parseMsg)
    }
  },
  created () {
    this.loadCannedMsg()
  },
  methods: {
    async loadCannedMsg () {
      const cannedmsgList = await api.macro.listCannedMsg()
      this.rawMsgList = cannedmsgList.map(msg => msg.msg)
    },
    selectMsg (msg) {
      this.$emit('change', msg)
    },
    parseMsg (msg) {
      let newMsg = msg
      const macros = msg.matchAll(/{{[^}]+}}/g)
      for (const macro of macros) {
        // remove {{ }} and convert to camelCase
        const macroName = macro[0].slice(2, -2).replace(/(-[a-zA-Z0-9])/g, (group) => {
          return group.toUpperCase().replace('-', '')
        })
        if (MACRO[macroName]) {
          const newVal = MACRO[macroName](this)
          if (newVal) {
            newMsg = newMsg.replace(macro, newVal)
          }
        }
      }
      return newMsg
    }
  }
}
</script>
<style lang="scss" scoped>
.cannedmsg {
  /deep/ {
    a.dropdown-item {
      width: 16rem;
      white-space: normal;
      padding: 0.25rem 0.75rem;
    }
  }
}
</style>
